# Project Server Notes

## Checkpoint 1

1. Lots of software today connects to remote servers, and can't work offline. 
   What are some advantages of using a program or an app which uses a remote server? What are some advantages of using a program or an app which is completely local?
A remote server is usually run by a large company, meaning that they usually have access to a wider amount of server hardware and have tech support available to fix issues. A local server is typically more private with less users, meaning that you would not have to deal with changing speeds due to an increase in users. They would also be much more customizable since they run locally, and are more secure.


2. You just ran a server on your own computer, and connected to it as a client 
   on the same computer. In what other situations might it be useful to run a server
   on your computer, where you're the only client, on the same computer?
This would be a great environment for testing and debugging before pushing out to a larger user base. Many problems are typically found during this step in development.


## Checkpoint 2

3. Choose a program (Steam), web app (Google Docs), or app (Weather) that you use 
   frequently. You can't observe the calls this program is making to its server 
   (unless you have fancy tools), but you can infer some of the calls based on the 
   program's behavior. Describe a few routes which you think may exist for your 
   chosen program's backend server.
For a program like Steam, there would several routes able to be taken since there are four major starting folders for lack of a better term (Store, Library, Community, and the username of the current user). The store can then be broken up by genre, pricing, reviews, number of players, and can even stack on top of each other in certain circumstance. They can even route to each other since when a game is purchased from the store, it is then added to the Library folder.


4. In your own words, what is an exception? When might it be useful to handle an 
   exception? When is it better not to handle an exception, and instead let the 
   program crash?
An exception involves recoverable errors. It would be useful to handle an exception if the error shown is something that can be easily handled. It may be useful to not handle an exception if a program has a security risk since it would be best to force a crash rather than allow unauthorized access to private portions of the program.

